import { SlashCommandBuilder, ChatInputCommandInteraction } from "discord.js";
import { guildID } from "../config.json";

export default abstract class DiscordInteractionCommand {
    public name: string;
    public description: string;
    public builder: SlashCommandBuilder;

    protected GUILD_ID: string;

    protected constructor(name: string, description: string) {
        this.name = name;
        this.description = description;
        this.builder = new SlashCommandBuilder();

        this.builder.setName(this.name);
        this.builder.setDescription(this.description);

        this.GUILD_ID = guildID;
    }

    public abstract execute(interaction: ChatInputCommandInteraction): Error | Promise<void | any>;
}
